<?php
/*
Plugin Name: Feedburner Email Widget
Version: 1.0.0
Plugin URI: http://wyrihaximus.net/projects/wordpress/feedburner-email-widget/
Description: Allows you to add a Feedburner Email Subscription widget to one of your sidebars.
Author: WyriHaximus
Author URI: http://wyrihaximus.net/
*/
class FeedburnerEmailWidget extends WP_Widget {
    function FeedburnerEmailWidget() {
        $widget_ops = array('classname' => 'FeedburnerEmailWidget', 'description' => 'Allows you to add a Feedburner Email Subscription widget to one of your sidebars.' );
        $this->WP_Widget('FeedburnerEmailWidget', 'Feedburner Email Widget', $widget_ops);
    }
    function form($instance) {
        $title = esc_attr($instance['title']);
        $uri = esc_attr($instance['uri']);
        $above_email = esc_attr($instance['above_email']);
        $below_email = esc_attr($instance['below_email']);
        $subscribe_btn = esc_attr($instance['subscribe_btn']);
        $show_link = esc_attr($instance['show_link']);
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('uri'); ?>"><?php _e('Feedburner feed URL:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('uri'); ?>" name="<?php echo $this->get_field_name('uri'); ?>" type="text" value="<?php echo $uri; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('above_email'); ?>"><?php _e('Above input text:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('above_email'); ?>" name="<?php echo $this->get_field_name('above_email'); ?>" type="text" value="<?php echo $above_email; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('below_email'); ?>"><?php _e('Below input text:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('below_email'); ?>" name="<?php echo $this->get_field_name('below_email'); ?>" type="text" value="<?php echo $below_email; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('subscribe_btn'); ?>"><?php _e('Submit button caption:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('subscribe_btn'); ?>" name="<?php echo $this->get_field_name('subscribe_btn'); ?>" type="text" value="<?php echo $subscribe_btn; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('show_link'); ?>"><?php _e('Show feedburner link:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('show_link'); ?>" name="<?php echo $this->get_field_name('show_link'); ?>" type="checkbox"<?php echo (($show_link) ? ' checked' : ''); ?> /></label></p>
        <?php
    }

    function update($new_instance, $old_instance) {
        return $new_instance;
    }
    function widget($args, $instance) {
        extract($args, EXTR_SKIP);
        $html = $before_widget;
        $title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
        $uri = empty($instance['uri']) ? false : $instance['uri'];
        $above_email = empty($instance['above_email']) ? false : $instance['above_email'];
        $below_email = empty($instance['below_email']) ? false : $instance['below_email'];
        $subscribe_btn = empty($instance['subscribe_btn']) ? 'Subscribe' : $instance['subscribe_btn'];
        $show_link = $instance['show_link'] ? true : false;
        if($uri) {
            $uri = str_replace('http://feeds.feedburner.com/','',$uri);
            if (!empty($title)) {
                $html .= $before_title . $title . $after_title;
            }
            $html .= '<form style="border:opx solid #ccc;padding:0px;text-align:center;" action="http://feedburner.google.com/fb/a/mailverify" method="post" onsubmit="window.open(\'http://feedburner.google.com/fb/a/mailverify?uri=' . $uri . '\', \'popupwindow\', \'scrollbars=yes,width=550,height=520\');return true">';
            if($above_email) {
                $html .= '<p>' . $above_email . '</p>';
            }
            $html .= '<p><input type="text" style="width:140px" name="email"/>';
            $html .= '<input type="hidden" value="' . $uri . '" name="uri"/>';
            $html .= '<input type="hidden" name="loc" value="en_US"/></p>';
            if($below_email) {
                $html .= '<p>' . $below_email . '</p>';
            }
            $html .= '<p><input type="submit" value="' . $subscribe_btn . '" /></p>';
            if($show_link) {
                $html .= '<p>Delivered by <a href="http://feedburner.google.com" target="_blank">FeedBurner</a></p>';
            }
            $html .= '</form>';
        }
        $html .= $after_widget;
        echo($html);
    }
}
add_action('widgets_init', create_function('', 'return register_widget(\'FeedburnerEmailWidget\');'));